Index: branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 8064)
+++ branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 8190)
@@ -85,7 +85,7 @@
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       REAL(wp), POINTER, DIMENSION(:,:,:) ::  ztrdu, ztrdv
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   z_rhd_st  ! tmp density storage for pressure corr 
-      REAL(wp), DIMENSION(jpi,jpj)     ::   z_gru_st  ! tmp ua trends storage for pressure corr
-      REAL(wp), DIMENSION(jpi,jpj)     ::   z_grv_st  ! tmp va trends storage for pressure corr
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   ::   z_rhd_st  ! tmp density storage for pressure corr
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)     ::   z_gru_st  ! tmp ua trends storage for pressure corr
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:)     ::   z_grv_st  ! tmp va trends storage for pressure corr
       !!----------------------------------------------------------------------
       !
@@ -99,4 +99,10 @@
       !
       IF ( ln_bias .AND. ln_bias_pc_app ) THEN
+
+         !Allocate space for tempory variables
+         ALLOCATE( z_rhd_st(jpi,jpj,jpk), &
+            &      z_gru_st(jpi,jpj),     &
+            &      z_grv_st(jpi,jpj)      )
+
          z_rhd_st(:,:,:) = rhd(:,:,:)     ! store orig density 
          rhd(:,:,:)      = rhd_pc(:,:,:)  ! use pressure corrected density
@@ -105,4 +111,5 @@
          z_grv_st(:,:)   = grv(:,:)
          grv(:,:)        = grv_pc(:,:)
+
       ENDIF
       !
@@ -130,4 +137,9 @@
          gru(:,:)   = z_gru_st(:,:)
          grv(:,:)   = z_grv_st(:,:)
+
+         !Deallocate tempory variables
+         DEALLOCATE( z_rhd_st(jpi,jpj,jpk), &
+            &        z_gru_st(jpi,jpj),     &
+            &        z_grv_st(jpi,jpj)      )
       ENDIF
       !
Index: branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 8064)
+++ branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/DYN/sshwzv.F90	(revision 8190)
@@ -106,5 +106,4 @@
                  hdivn(:,:,jk) = hdivn(:,:,jk) - ( ssh_iau(:,:) / ( ht_0(:,:) + 1.0 - ssmask(:,:) ) ) * ( e3t_0(:,:,jk) / fse3t_n(:,:,jk) ) * tmask(:,:,jk) 
         END DO
-        CALL lbc_lnk( hdivn, 'T', 1. ) ! Not sure that's necessary
       ENDIF
 #endif
Index: branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90	(revision 8064)
+++ branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_ice.F90	(revision 8190)
@@ -114,7 +114,9 @@
    
    !
+#if defined key_asminc
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   ndaice_da          !: NEMO fresh water flux to ocean due to data assim
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   nfresh_da          !: NEMO salt flux to ocean due to data assim
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)   ::   nfsalt_da          !: NEMO ice concentration change/second from data assim
+#endif
       
 #endif
@@ -170,5 +172,7 @@
                 ss_iov(jpi,jpj)       , fr_iu(jpi,jpj)        , fr_iv(jpi,jpj)        , &
                 a_i(jpi,jpj,ncat)     , topmelt(jpi,jpj,ncat) , botmelt(jpi,jpj,ncat) , &
+#if defined key_asminc
                 ndaice_da(jpi,jpj)    , nfresh_da(jpi,jpj)    , nfsalt_da(jpi,jpj)    , &
+#endif
                 sstfrz(jpi,jpj)       , STAT= ierr(1) )
    ! Alex West: Allocating tn_ice with 5 categories.  When NEMO is used with CICE, this variable
Index: branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90	(revision 8064)
+++ branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90	(revision 8190)
@@ -303,4 +303,5 @@
       CALL wrk_dealloc( jpi,jpj, ztmp1, ztmp2 )
 
+#if defined key_asminc
 	   ! Initialize fresh water and salt fluxes from data assim   
 	   !  and data assimilation index to cice 
@@ -308,4 +309,5 @@
 	   nfsalt_da(:,:) = 0.0   
 	   ndaice_da(:,:) = 0.0         
+#endif
       !
       IF( nn_timing == 1 )  CALL timing_stop('cice_sbc_init')
Index: branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 8064)
+++ branches/UKMO/dev_r5518_GO6_package_inc_asm/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 8190)
@@ -300,5 +300,4 @@
          IF ( .NOT. lk_dynspg_ts ) THEN                     ! eos already called in time-split case
                              CALL eos    ( tsn, rhd, rhop, fsdept_n(:,:,:) )  ! now in situ density for hpg computation
-                             CALL lbc_lnk( rhd, 'T', 1.0_wp )
          IF( ln_zps .AND. .NOT. ln_isfcav)                                   &
                &             CALL zps_hde    ( kstp, jpts, tsn, gtsu, gtsv,  &    ! Partial steps: before horizontal gradient